%global commit 99eedfa6e02d67224bf91877a869eebcbc4de1e3
%global snapdate 20230512

Name:           c4fs
Summary:        C++ file system utilities
Version:        0.0.1^%{snapdate}git%(c='%{commit}'; echo "${c:0:7}")
%global so_version 0.0.1
Release:    1%{?dist}

License:        MIT
URL:            https://github.com/biojppm/c4fs
Source0:         %{url}/archive/%{commit}/c4fs-%{commit}.tar.gz

Patch0:          c4fs-1abba00-external-c4core.patch

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  c4project
BuildRequires:  ninja-build

BuildRequires:  cmake(c4core)

BuildRequires:  doctest-devel
BuildRequires:  doctest-static

%description
%{summary}.


%package devel
Summary:        Development files for c4fs

Requires:       c4fs = %{version}-%{release}
Requires:       c4core-devel

%description devel
The c4fs-devel package contains libraries and header files for developing
applications that use c4fs.


%prep
%autosetup -n c4fs-%{commit} -p1


find ext
cp -rp '%{_datadir}/cmake/c4project' ext/c4core/cmake

sed -r -i \
    -e 's/(LIBS.*)\bdoctest\b/\1/' \
    -e 's/(c4_setup_testing\()DOCTEST\)/\1\)/' \
    test/CMakeLists.txt


%build
%cmake -GNinja \
  -DC4FS_CACHE_DOWNLOAD_DOCTEST:PATH=/ \
  -DC4FS_BUILD_TESTS=ON
%cmake_build


%install
%cmake_install
if [ '%{_libdir}' != '%{_prefix}/lib' ]
then
  mkdir -p '%{buildroot}%{_libdir}'
  mv -v %{buildroot}%{_prefix}/lib/libc4fs.so* '%{buildroot}%{_libdir}/'
  mkdir -p '%{buildroot}%{_libdir}/cmake'
  mv -v %{buildroot}%{_prefix}/lib/cmake/c4fs '%{buildroot}%{_libdir}/cmake/'
  find %{buildroot}%{_libdir}/cmake/c4fs -type f -name '*.cmake' -print0 |
    xargs -r -t -0 sed -r -i "s@/lib/@/$(basename '%{_libdir}')/@"
fi


%check
%cmake_build --target c4fs-test-run-verbose


%files
%license LICENSE.txt
%doc README.md
%{_libdir}/libc4fs.so.%{so_version}


%files devel
%{_includedir}/c4/fs
%{_libdir}/libc4fs.so
%{_libdir}/cmake/c4fs


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.0.1^20230512git99eedfa-1
- initial build
